"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.addOrUpdateChannel = addOrUpdateChannel;
exports.leaveChannel = leaveChannel;
exports.archiveChannel = archiveChannel;
exports.userIsTyping = userIsTyping;
function addOrUpdateChannel(state, _ref) {
  let channel = _ref.channel;

  let existingChannel = state[channel.id];

  return _extends({}, state, {
    [channel.id]: _extends({}, existingChannel, channel)
  });
}

function leaveChannel(state, message, userId) {
  let channel = state[message.channel];
  if (!channel) return state;

  return _extends({}, state, {
    [channel.id]: _extends({}, channel, {
      members: [...channel.members.slice(0, channel.members.indexOf(userId)), ...channel.members.slice(channel.members.indexOf(userId) + 1)],
      is_member: false
    })
  });
}

function archiveChannel(state, message, is_archived) {
  let channel = state[message.channel];
  if (!channel) return state;

  return _extends({}, state, {
    [channel.id]: _extends({}, channel, {
      is_archived
    })
  });
}

function userIsTyping(state, message, isTyping) {
  let channel = state[message.channel];
  if (!channel) return state;

  let existingTypists = channel.typing || [];

  return _extends({}, state, {
    [channel.id]: _extends({}, channel, {
      typing: isTyping ? [...existingTypists, message.user] : [...existingTypists.slice(0, existingTypists.indexOf(message.user)), ...existingTypists.slice(existingTypists.indexOf(message.user) + 1)]
    })
  });
}